#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

void fatal ( char *comment ) {
	perror(comment);
	exit(0);
}

int main ( int ac, char **av ) {
	// Socket erzeugen
	int s = socket(AF_INET,SOCK_DGRAM,0);
	if (s == -1) fatal("socket");

	// Socket an gewuenschten Port 4211 fest binden
	struct sockaddr_in addr;
	memset((char *) &addr,0,sizeof(addr));
	addr.sin_family = PF_INET;
	unsigned long inaddr_any = INADDR_ANY;
	memcpy(&(addr.sin_addr),&inaddr_any,sizeof(addr.sin_addr));
	addr.sin_port = htons(4211);
	int ret = bind(s,(struct sockaddr *) &addr, sizeof(addr));
	if (ret == -1) fatal("bind");
	printf("Warte auf Nachrichten an Port 4211 ...\n");

	// Hinreichend grossen Puffer bereitstellen
	char buffer[65536];
	char *ack = "ACK";

	long n = 0; // Zaehlt die Anzahl der empfangenen Nachrichten
	// Auf unbestimmte Zeit Nachrichten empfangen
	while (1) {
		struct sockaddr sender;
		socklen_t sender_len = sizeof(sender);
		int ret = recvfrom(s,buffer,sizeof(buffer),0,&sender,&sender_len);  
		if (ret == -1) fatal("recvfrom");
		ret = sendto(s,ack,3,0,&sender,sender_len);
		if (ret == -1) fatal("sendto");
		printf("Nachricht %ld erhalten\n",++n);
	}
}
